#define _XOPEN_SOURCE
#define _ISOC99_SOURCE

/* Large fule support */
#ifdef LARGEFILE
# define _FILE_OFFSET_BITS	64	/* POSIX large file support for fopen/fstat		*/
# define _LARGEFILE_SOURCE	1	/* Linux/xBSD/HP-UX/Solaris support for fseeko/ftello	*/
# define _LARGE_FILES 		1	/* AIX support for large file and fseeko/ftello		*/
#endif


#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <locale.h>
#include <langinfo.h>
#include <errno.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <math.h>
#include <dirent.h>


#define MAXLEN		8192
#define MAXFILENAME	512L
#define MAXDATETIME	128L
#define MAXUSERNAME	128
#define MAXUSERDESC	256L
#define MAXIP		16
#define MAXARGS		32
#define SAMAXTIMET	1555555555L

#define CMDRM		"/bin/rm"
#define CMDSORT		"/usr/bin/sort"


#define SAsetbit(src, bitnr) src |= (0x01 << bitnr)
#define SAgetbit(src, bitnr) (src & (0x01 << bitnr))
#define SAmin(a, b) (a < b) ? a : b
#define SAmax(a, b) (a > b) ? a : b


#include "reports/r_efficiency.h"
#include "reports/r_users.h"
#include "reports/r_topsites.h"
#include "reports/r_topuser.h"
#include "reports/r_typical.h"
#include "reports/r_usergraphs.h"
#include "reports/r_userdatetime.h"
#include "reports/r_reports.h"
#include "reports/r_list.h"
#include "reports/r_index.h"

#include "logformats/l_squid_native.h"
#include "logformats/l_clf_native.h"
#include "logformats/l_combined_native.h"
#include "logformats/l_postfix_syslog.h"
#include "logformats/l_qmail_syslog.h"
#include "logformats/l_cgp_native.h"
#include "logformats/l_logformats.h"

#include "work/w_config.h"
#include "work/w_system.h"
#include "work/w_fs.h"
#include "work/w_internal.h"
#include "work/w_log_operations.h"

#include "free-sa.h"
