#include "global.h"


#define F_INITREPORTS		"InitReports"
void InitReports(void) {
    short int i;
    char tfname[MAXFILENAME];

    /* Clear temporary directory */
    snprintf(tfname, sizeof(tfname), "%s/*", cfg.TmpDir);
    SAsystem(CMDRM, CMDRM, "-rf", tfname, NULL);

    /* TT_UNS: open */
    for (i = 0; i < TTNUMBER; i++) if (cfg.TTR[i]) {
    	snprintf(TT[i].fname, sizeof(TT[i].fname), TEMPL_TT_UNS, cfg.TmpDir, icfg.TTRname[i]);
	TT[i].file = SAfopenI("w", TT[i].fname);
	TT[i].count = 0;
    }

    /* Clear efficiency data */
    if (cfg.PER) memset(ec, 0, sizeof(ec));
}


#define F_GENERATEREPORTS	"GenerateReports"
void GenerateReports(time_t rsdate, time_t redate) {
    short int i, j;
    char tfname[MAXFILENAME];
    FILE *DF;


    /* Create reports directory */
    snprintf(tfname, sizeof(tfname), "%s/%ld-%ld-", cfg.TargetDir, rsdate, redate);
    j = strlen(tfname);
    
    for (i = 1; ; i++) {
	snprintf(&tfname[j], sizeof(tfname) - j, "%hd", i);
	if (mkdir(tfname, 0755)) {
	    if (errno != EEXIST) SAexit(F_GENERATEREPORTS, "%s. %s", tfname, strerror(errno));
	} else break;
    }
    
    /* Save reports directory */
    icfg.ReportDir = SAstrcpy(tfname);

    ReportTypical();
    ReportTopUser();
    ReportUsers();
    if (cfg.TSR) ReportTopSites();
    if (cfg.PER) ReportProxyEfficiency();
    ReportList();

    /* DF: all */
    DF = SAfopen("w", "%s/%s", icfg.ReportDir, icfg.DFname);
    fprintf(DF, "%s\n%s\n%'.0f\n%'d\n", icfg.Period, cfg.Name, allBytes[0], ccueCount);
    SAfclose(DF, icfg.DFname);

    ReportIndex();
}
