typedef struct Config {
    char	INameUser;
    char	FullURL;
    char	ResolveIP;
    char	FullTraffic;
    char	ShowInfo;
    char	Indics;
    char	Overwrite;
    const char	*TmpDir;
    const char	*TargetDir;
    const char	*Site;
    const char	*Log;
    const char	*Config;
    const char	*utFile;
    const char	*dldFile;
    const char	*locFile;
    const char	*gfFile;
    const char	*Logo;
    const char	*Name;
    const char  *Locale;
    char	TSR;
    char	PER;
    char	TTR[TTNUMBER];
    short int	ttUserLimit[TTNUMBER];
    short int	LogFormat;
    short int	URLLimit;
    short int	AutoRecords;
} Config;

typedef struct owConfig {
    char	*Log;
} owConfig;

typedef struct iConfig {
    const char	*ReportDir;
    const char	*CharSet;
    const char	*DFname;
    const char	*IRname;
    const char	*LRname;
    const char	*TURname;
    const char	*TSRname;
    const char	*PERname;
    const char	*TTRname[TTNUMBER];
    char	Mode;
    short int	SYear;
    time_t	SDate;
    short int	EYear;
    time_t	EDate;
    short int	LocDateLen;
    short int	dldCount;
    short int	utCount;
    short int	ueCount;
    char	GF;
    char	**Downloads;
    struct SAuconv *Usertab;
    char	Period[32];
} iConfig;

typedef struct Localisation {
    const char	*No;
    const char	*User;
    const char	*Connections;
    const char	*Seconds;
    const char	*Bytes;
    const char	*URL;
    const char	*Period;
    const char	*SortFieldNOrder;
    const char	*Users;
    const char	*Served;
    const char	*Actual;
    const char	*Cashed;
    const char	*TrafType;
    const char	*OthLocal;
    const char	*TopUser;
    const char	*TopSites;
    const char	*PEfficiency;
    const char	*DnT;
    const char	*DsT;
    const char	*DoM;
    const char	*Asc;
    const char	*Desc;
    const char	*TOTAL;
    const char	*AVERAGE;
    const char	*MAXIMUM;
    const char	*Code;
    const char	*GeneratedBy;
    const char	*Configuration;
    const char	*GenerationD;
    const char	*PSP;
    const char	*TT[TTNUMBER];
    const char	*S;
} Localisation;

typedef struct GFConfig {
    short int	inameCount;
    short int	urlCount;
    char	inameMode;
    char	urlMode;
    char	**inames;
    char	**urls;
} GFConfig;


extern struct Config cfg;
extern struct owConfig owcfg;
extern struct iConfig icfg;
extern struct Localisation defloc;
extern struct Localisation *loc;
extern struct GFConfig gfcfg;


extern void InitConfigWithCL(int argc, char **argv);
extern void InitConfig(void);
extern void InitLocale(void);


#define	LOCSIZE	sizeof(Localisation)/sizeof(char *)
